| Fast DDS Version 3.3.0 Fast DDS

Loading...
Searching...
No Matches
RTPSWriter Class Referenceabstract
eProsima Fast DDS API Reference » RTPS » Writer Module

Class RTPSWriter, manages the sending of data to the readers. More...

`#include <RTPSWriter.hpp>`

Inheritance diagram for RTPSWriter:
[legend]

## Public Member Functions

virtual FASTDDS_EXPORTED_API bool | matched_reader_add (const SubscriptionBuiltinTopicData &info)=0
| Add a matched reader represented by its attributes.
virtual FASTDDS_EXPORTED_API bool | matched_reader_remove (const GUID_t &reader_guid)=0
| Remove a matched reader.
virtual FASTDDS_EXPORTED_API bool | matched_reader_is_matched (const GUID_t &reader_guid)=0
| Tells us if a specific Reader is matched against this writer.
virtual FASTDDS_EXPORTED_API void | reader_data_filter (IReaderDataFilter *filter)=0
| Set a content filter to perform content filtering on this writer.
virtual FASTDDS_EXPORTED_API const IReaderDataFilter * | reader_data_filter () const =0
| Get the content filter used to perform content filtering on this writer.
virtual FASTDDS_EXPORTED_API bool | has_been_fully_delivered (const SequenceNumber_t &seq_num) const =0
| Check if a specific change has been delivered to the transport layer of every matched remote RTPSReader at least once.
virtual FASTDDS_EXPORTED_API bool | is_acked_by_all (const SequenceNumber_t &seq_num) const =0
| Check if a specific change has been acknowledged by all Readers.
virtual FASTDDS_EXPORTED_API bool | wait_for_all_acked (const dds::Duration_t &max_wait)=0
| Waits until all changes were acknowledged or max_wait.
virtual FASTDDS_EXPORTED_API void | update_attributes (const WriterAttributes &att)=0
| Update the Attributes of the Writer.
virtual FASTDDS_EXPORTED_API WriterListener * | get_listener () const =0
| Get listener.
virtual FASTDDS_EXPORTED_API bool | set_listener (WriterListener *listener)=0
| Set the listener.
virtual FASTDDS_EXPORTED_API bool | is_async () const =0
| Get the publication mode.
virtual FASTDDS_EXPORTED_API bool | get_disable_positive_acks () const =0
| Returns if disable positive ACKs QoS is enabled.
virtual FASTDDS_EXPORTED_API bool | matched_readers_guids (std::vector< GUID_t > &guids) const =0
| Fills the provided vector with the GUIDs of the matched readers.
Public Member Functions inherited from Endpoint
FASTDDS_EXPORTED_API const GUID_t & | getGuid () const
| Get associated GUID.
FASTDDS_EXPORTED_API RecursiveTimedMutex & | getMutex ()
| Get mutex.
FASTDDS_EXPORTED_API EndpointAttributes & | getAttributes ()
| Get associated attributes.

## Protected Member Functions

| RTPSWriter (RTPSParticipantImpl *impl, const GUID_t &guid, const WriterAttributes &att)
virtual | ~RTPSWriter ()
Protected Member Functions inherited from Endpoint
| Endpoint ()=default
| Endpoint (RTPSParticipantImpl *pimpl, const GUID_t &guid, const EndpointAttributes &att)
virtual | ~Endpoint ()

## Additional Inherited Members

Protected Attributes inherited from Endpoint
RTPSParticipantImpl * | mp_RTPSParticipant
| Pointer to the RTPSParticipant containing this endpoint.
const GUID_t | m_guid
| Endpoint GUID.
EndpointAttributes | m_att
| Endpoint Attributes.
RecursiveTimedMutex | mp_mutex
| Endpoint Mutex.
uint32_t | fixed_payload_size_ = 0
| Fixed size of payloads.

## Detailed Description

Class RTPSWriter, manages the sending of data to the readers.

Is always associated with a HistoryCache.

## Constructor & Destructor Documentation

## ◆ RTPSWriter()

RTPSWriter | ( | RTPSParticipantImpl * | impl,
|  | const GUID_t & | guid,
|  | const WriterAttributes & | att )

protected

## ◆ ~RTPSWriter()

virtual ~RTPSWriter | ( |  | ) |

protected virtual

## Member Function Documentation

## ◆ get_disable_positive_acks()

virtual FASTDDS_EXPORTED_API bool get_disable_positive_acks | ( |  | ) | const

pure virtual

Returns if disable positive ACKs QoS is enabled.

Returns
  Best effort writers always return false. Reliable writers override this method.

## ◆ get_listener()

virtual FASTDDS_EXPORTED_API WriterListener * get_listener | ( |  | ) | const

pure virtual

Get listener.

Returns
  Listener

## ◆ has_been_fully_delivered()

virtual FASTDDS_EXPORTED_API bool has_been_fully_delivered | ( | const SequenceNumber_t & | seq_num | ) | const

pure virtual

Check if a specific change has been delivered to the transport layer of every matched remote RTPSReader at least once.

Parameters

  seq_num | Sequence number of the change to check.

Returns
  true if delivered. False otherwise.

## ◆ is_acked_by_all()

virtual FASTDDS_EXPORTED_API bool is_acked_by_all | ( | const SequenceNumber_t & | seq_num | ) | const

pure virtual

Check if a specific change has been acknowledged by all Readers.

Is only useful in reliable Writer. In BE Writers returns false when pending to be sent.

Parameters

  seq_num | Sequence number to check.

Returns
  True if acknowledged by all.

## ◆ is_async()

virtual FASTDDS_EXPORTED_API bool is_async | ( |  | ) | const

pure virtual

Get the publication mode.

Returns
  publication mode

## ◆ matched_reader_add()

virtual FASTDDS_EXPORTED_API bool matched_reader_add | ( | const SubscriptionBuiltinTopicData & | info | ) |

pure virtual

Add a matched reader represented by its attributes.

Parameters

  info | Subscription info of the reader being matched.

Returns
  True if added.

## ◆ matched_reader_is_matched()

virtual FASTDDS_EXPORTED_API bool matched_reader_is_matched | ( | const GUID_t & | reader_guid | ) |

pure virtual

Tells us if a specific Reader is matched against this writer.

Parameters

  reader_guid | GUID of the reader to check.

Returns
  True if it was matched.

## ◆ matched_reader_remove()

virtual FASTDDS_EXPORTED_API bool matched_reader_remove | ( | const GUID_t & | reader_guid | ) |

pure virtual

Remove a matched reader.

Parameters

  reader_guid | GUID of the reader to remove.

Returns
  True if removed.

## ◆ matched_readers_guids()

virtual FASTDDS_EXPORTED_API bool matched_readers_guids | ( | std::vector< GUID_t > & | guids | ) | const

pure virtual

Fills the provided vector with the GUIDs of the matched readers.

Parameters

  [out] | guids | Vector to be filled with the GUIDs of the matched readers.

Returns
  True if the operation was successful.

## ◆ reader_data_filter() [1/2]

virtual FASTDDS_EXPORTED_API const IReaderDataFilter * reader_data_filter | ( |  | ) | const

pure virtual

Get the content filter used to perform content filtering on this writer.

Returns
  The content filter used on this writer.

## ◆ reader_data_filter() [2/2]

virtual FASTDDS_EXPORTED_API void reader_data_filter | ( | IReaderDataFilter * | filter | ) |

pure virtual

Set a content filter to perform content filtering on this writer.

This method sets a content filter that will be used to check whether a cache change is relevant for a reader or not.

Parameters

  filter | The content filter to use on this writer. May be `nullptr` to remove the content filter (i.e. treat all samples as relevant).

## ◆ set_listener()

virtual FASTDDS_EXPORTED_API bool set_listener | ( | WriterListener * | listener | ) |

pure virtual

Set the listener.

Parameters

  listener | Pointer to the listener.

Returns
  True if correctly set.

## ◆ update_attributes()

virtual FASTDDS_EXPORTED_API void update_attributes | ( | const WriterAttributes & | att | ) |

pure virtual

Update the Attributes of the Writer.

Parameters

  att | New attributes

## ◆ wait_for_all_acked()

virtual FASTDDS_EXPORTED_API bool wait_for_all_acked | ( | const dds::Duration_t & | max_wait | ) |

pure virtual

Waits until all changes were acknowledged or max_wait.

Parameters

  max_wait | Maximum time to wait.

Returns
  True if all were acknowledged.

The documentation for this class was generated from the following file:

- include/fastdds/rtps/writer/RTPSWriter.hpp